import i18next from "i18next";
import DeveloperError from "terriajs-cesium/Source/Core/DeveloperError";
function readText(file) {
    return new Promise((resolve, reject) => {
        if (typeof file === "undefined") {
            throw new DeveloperError(i18next.t("core.readText.fileRequired"));
        }
        const reader = new FileReader();
        reader.readAsText(file);
        reader.onload = function (event) {
            var _a;
            const allText = (_a = event.target) === null || _a === void 0 ? void 0 : _a.result;
            resolve((allText !== null && allText !== void 0 ? allText : undefined));
        };
        reader.onerror = function (e) {
            reject(e);
        };
    });
}
export default readText;
//# sourceMappingURL=readText.js.map