import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useState } from "react";
import { observer } from "mobx-react";
import CommonStrata from "../../Models/Definition/CommonStrata";
import Styles from "./parameter-editors.scss";
const NumberParameterEditor = ({ parameter }) => {
    const [value, setValue] = useState(0);
    useEffect(() => {
        if (parameter.defaultValue !== undefined) {
            setValue(parameter.defaultValue);
        }
    }, [parameter.defaultValue]);
    const onChange = (e) => {
        setValue(parseFloat(e.target.value));
        parameter.setValue(CommonStrata.user, parseFloat(e.target.value));
    };
    const min = (parameter.minimum || "");
    const max = (parameter.maximum || "");
    return (_jsx("input", { className: Styles.field, type: "number", onChange: onChange, value: value, min: min, max: max }));
};
export default observer(NumberParameterEditor);
//# sourceMappingURL=NumberParameterEditor.js.map