import { Component } from "react";
/**
 * An error boundary that raises the error to the user.
 */
export default class RaiseToUserErrorBoundary extends Component {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "state", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: { hasError: false }
        });
    }
    static getDerivedStateFromError(_error) {
        return {
            hasError: true
        };
    }
    componentDidCatch(error, _errorInfo) {
        this.props.viewState.terria.raiseErrorToUser(error, this.props.terriaErrorOptions);
    }
    render() {
        return this.state.hasError ? null : this.props.children;
    }
}
//# sourceMappingURL=RaiseToUserErrorBoundary.js.map