# Customizing your Data's Appearance

You can customize your data's appearance by specifying the style traits in [initialization files](../../customizing/initialization-files.md). Without such guidance, TerriaJS chooses default settings, eg. the size of the points, the color scale, how to cluster values in the legend, and how to display feature information in the "feature info panel".

This section explains how you can use such a file to improve the look of your data:

- [Customizing the Appearance of Tabular and Vector Data](./tabular-vector-data.md)
- [Customizing the Appearance of Imagery Data](./imagery-data.md)
- [Customizing the Feature Info Template](./feature-info-template.md)
- [Using Model Dimensions to customise the Workbench](./model-dimensions.md)
